/* Auto-generated by genmsg_java.py for file /opt/ros/electric/stacks/arm_navigation/arm_navigation_msgs/msg/CollisionObject.msg */

package ros.pkg.arm_navigation_msgs.msg;

import java.nio.ByteBuffer;

public class CollisionObject extends ros.communication.Message {

  public ros.pkg.std_msgs.msg.Header header = new ros.pkg.std_msgs.msg.Header();
  public java.lang.String id = new java.lang.String();
  public float padding;
  public ros.pkg.arm_navigation_msgs.msg.CollisionObjectOperation operation = new ros.pkg.arm_navigation_msgs.msg.CollisionObjectOperation();
  public java.util.ArrayList<ros.pkg.arm_navigation_msgs.msg.Shape> shapes = new java.util.ArrayList<ros.pkg.arm_navigation_msgs.msg.Shape>();
  public java.util.ArrayList<ros.pkg.geometry_msgs.msg.Pose> poses = new java.util.ArrayList<ros.pkg.geometry_msgs.msg.Pose>();

  public CollisionObject() {
  }

  public static java.lang.String __s_getDataType() { return "arm_navigation_msgs/CollisionObject"; }
  public java.lang.String getDataType() { return __s_getDataType(); }
  public static java.lang.String __s_getMD5Sum() { return "7b972910c23ece1b873b3de0cf92ba97"; }
  public java.lang.String getMD5Sum() { return __s_getMD5Sum(); }
  public static java.lang.String __s_getMessageDefinition() { return "# a header, used for interpreting the poses\n" +
"Header header\n" +
"\n" +
"# the id of the object\n" +
"string id\n" +
"\n" +
"# The padding used for filtering points near the object.\n" +
"# This does not affect collision checking for the object.  \n" +
"# Set to negative to get zero padding.\n" +
"float32 padding\n" +
"\n" +
"#This contains what is to be done with the object\n" +
"CollisionObjectOperation operation\n" +
"\n" +
"#the shapes associated with the object\n" +
"arm_navigation_msgs/Shape[] shapes\n" +
"\n" +
"#the poses associated with the shapes - will be transformed using the header\n" +
"geometry_msgs/Pose[] poses\n" +
"\n" +
"================================================================================\n" +
"MSG: std_msgs/Header\n" +
"# Standard metadata for higher-level stamped data types.\n" +
"# This is generally used to communicate timestamped data \n" +
"# in a particular coordinate frame.\n" +
"# \n" +
"# sequence ID: consecutively increasing ID \n" +
"uint32 seq\n" +
"#Two-integer timestamp that is expressed as:\n" +
"# * stamp.secs: seconds (stamp_secs) since epoch\n" +
"# * stamp.nsecs: nanoseconds since stamp_secs\n" +
"# time-handling sugar is provided by the client library\n" +
"time stamp\n" +
"#Frame this data is associated with\n" +
"# 0: no frame\n" +
"# 1: global frame\n" +
"string frame_id\n" +
"\n" +
"================================================================================\n" +
"MSG: arm_navigation_msgs/CollisionObjectOperation\n" +
"#Puts the object into the environment\n" +
"#or updates the object if already added\n" +
"byte ADD=0\n" +
"\n" +
"#Removes the object from the environment entirely\n" +
"byte REMOVE=1\n" +
"\n" +
"#Only valid within the context of a CollisionAttachedObject message\n" +
"#Will be ignored if sent with an CollisionObject message\n" +
"#Takes an attached object, detaches from the attached link\n" +
"#But adds back in as regular object\n" +
"byte DETACH_AND_ADD_AS_OBJECT=2\n" +
"\n" +
"#Only valid within the context of a CollisionAttachedObject message\n" +
"#Will be ignored if sent with an CollisionObject message\n" +
"#Takes current object in the environment and removes it as\n" +
"#a regular object\n" +
"byte ATTACH_AND_REMOVE_AS_OBJECT=3\n" +
"\n" +
"# Byte code for operation\n" +
"byte operation\n" +
"\n" +
"================================================================================\n" +
"MSG: arm_navigation_msgs/Shape\n" +
"byte SPHERE=0\n" +
"byte BOX=1\n" +
"byte CYLINDER=2\n" +
"byte MESH=3\n" +
"\n" +
"byte type\n" +
"\n" +
"\n" +
"#### define sphere, box, cylinder ####\n" +
"# the origin of each shape is considered at the shape's center\n" +
"\n" +
"# for sphere\n" +
"# radius := dimensions[0]\n" +
"\n" +
"# for cylinder\n" +
"# radius := dimensions[0]\n" +
"# length := dimensions[1]\n" +
"# the length is along the Z axis\n" +
"\n" +
"# for box\n" +
"# size_x := dimensions[0]\n" +
"# size_y := dimensions[1]\n" +
"# size_z := dimensions[2]\n" +
"float64[] dimensions\n" +
"\n" +
"\n" +
"#### define mesh ####\n" +
"\n" +
"# list of triangles; triangle k is defined by tre vertices located\n" +
"# at indices triangles[3k], triangles[3k+1], triangles[3k+2]\n" +
"int32[] triangles\n" +
"geometry_msgs/Point[] vertices\n" +
"\n" +
"================================================================================\n" +
"MSG: geometry_msgs/Point\n" +
"# This contains the position of a point in free space\n" +
"float64 x\n" +
"float64 y\n" +
"float64 z\n" +
"\n" +
"================================================================================\n" +
"MSG: geometry_msgs/Pose\n" +
"# A representation of pose in free space, composed of postion and orientation. \n" +
"Point position\n" +
"Quaternion orientation\n" +
"\n" +
"================================================================================\n" +
"MSG: geometry_msgs/Quaternion\n" +
"# This represents an orientation in free space in quaternion form.\n" +
"\n" +
"float64 x\n" +
"float64 y\n" +
"float64 z\n" +
"float64 w\n" +
"\n" +
""; }
  public java.lang.String getMessageDefinition() { return __s_getMessageDefinition(); }

  public CollisionObject clone() {
    CollisionObject c = new CollisionObject();
    c.deserialize(serialize(0));
    return c;
  }

  public void setTo(ros.communication.Message m) {
    deserialize(m.serialize(0));
  }

  public int serializationLength() {
    int __l = 0;
    __l += header.serializationLength();
    __l += 4 + id.length();
    __l += 4; // padding
    __l += operation.serializationLength();
    __l += 4;
    for(ros.pkg.arm_navigation_msgs.msg.Shape val : shapes) {
      __l += val.serializationLength();
    }
    __l += 4;
    for(ros.pkg.geometry_msgs.msg.Pose val : poses) {
      __l += val.serializationLength();
    }
    return __l;
  }

  public void serialize(ByteBuffer bb, int seq) {
    header.serialize(bb, seq);
    Serialization.writeString(bb, id);
    bb.putFloat(padding);
    operation.serialize(bb, seq);
    bb.putInt(shapes.size());
    for(ros.pkg.arm_navigation_msgs.msg.Shape val : shapes) {
      val.serialize(bb, seq);
    }
    bb.putInt(poses.size());
    for(ros.pkg.geometry_msgs.msg.Pose val : poses) {
      val.serialize(bb, seq);
    }
  }

  public void deserialize(ByteBuffer bb) {
    header.deserialize(bb);
    id = Serialization.readString(bb);
    padding = bb.getFloat();
    operation.deserialize(bb);

    int __shapes_len = bb.getInt();
    shapes = new java.util.ArrayList<ros.pkg.arm_navigation_msgs.msg.Shape>(__shapes_len);
    for(int __i=0; __i<__shapes_len; __i++) {
      ros.pkg.arm_navigation_msgs.msg.Shape __tmp = new ros.pkg.arm_navigation_msgs.msg.Shape();
      __tmp.deserialize(bb);
      shapes.add(__tmp);;
    }

    int __poses_len = bb.getInt();
    poses = new java.util.ArrayList<ros.pkg.geometry_msgs.msg.Pose>(__poses_len);
    for(int __i=0; __i<__poses_len; __i++) {
      ros.pkg.geometry_msgs.msg.Pose __tmp = new ros.pkg.geometry_msgs.msg.Pose();
      __tmp.deserialize(bb);
      poses.add(__tmp);;
    }
  }

  @SuppressWarnings("all")
  public boolean equals(Object o) {
    if(!(o instanceof CollisionObject))
      return false;
    CollisionObject other = (CollisionObject) o;
    return
      header.equals(other.header) &&
      id.equals(other.id) &&
      padding == other.padding &&
      operation.equals(other.operation) &&
      shapes.equals(other.shapes) &&
      poses.equals(other.poses) &&
      true;
  }

  @SuppressWarnings("all")
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    long tmp;
    result = prime * result + (this.header == null ? 0 : this.header.hashCode());
    result = prime * result + (this.id == null ? 0 : this.id.hashCode());
    result = prime * result + Float.floatToIntBits(this.padding);
    result = prime * result + (this.operation == null ? 0 : this.operation.hashCode());
    result = prime * result + (this.shapes == null ? 0 : this.shapes.hashCode());
    result = prime * result + (this.poses == null ? 0 : this.poses.hashCode());
    return result;
  }
} // class CollisionObject

