from distutils.file_util import *
import os
import re

# modify config.py
if os.path.exists("config.py.dev"):
    raise "config.py.dev exists... cannot continue"
os.rename("config.py", "config.py.dev")
# - read current config
f = file("config.py.dev")
text = f.read()
f.close()
# - remove comments
comment = re.compile(r"'''.*?'''", re.DOTALL | re.MULTILINE)
text = comment.sub("", text) 
# - replace alchemy versions
vers = re.compile(r"alchemy_versions = {.*?\s}", re.DOTALL | re.MULTILINE)
text = vers.sub('alchemy_versions = {"Alchemy - latest": {"path": "/path/to/alchemy/bin", "usage": new_usage}}', text) 
# - replace mln file mask
text = text.replace('"wts*.mln"', '"*.mln"')
# - write new config
f = file("config.py", "w")
f.write(text)
f.close()

# create archive
os.system("tar -cf pymlns.tar config.py widgets.py queryTool.py learningTool.py MLN.py FOL.py RRF.py readme.html pyparsing.py jythonext.py jyparsing.py smokers.mln")
os.system("gzip pymlns.tar")

# restore old config
os.unlink("config.py")
os.rename("config.py.dev", "config.py")

# deploy
os.system("cp pymlns.tar.gz ~/homepage/mlns/")
os.system("chgrp infosys ~/homepage/mlns/pymlns.tar.gz")