import java.io.PrintStream;
import java.util.Properties;

import org.python.core.PyObject;
import org.python.util.PythonInterpreter;
import edu.tum.cs.srldb.Database;

import java.io.File;


public class CardinalityConstraintsDemo implements Runnable {

	protected int m_StudentCount, m_CourseCount, m_DefiniteCourseConstraint, m_lBCount, m_lICount, m_SampleCount;
	protected String m_Tag;
	static PythonInterpreter jython = null;
	protected static String script;

	public CardinalityConstraintsDemo(int studentCount, int courseCount, int definiteCourseConstraint) {
		m_StudentCount = studentCount;
		m_CourseCount = courseCount;
		m_DefiniteCourseConstraint = definiteCourseConstraint;
		m_lBCount = 6;
		m_lICount = 6;
		m_SampleCount = 1;
		m_Tag = "";
	}
	public CardinalityConstraintsDemo(int studentCount, int courseCount, int definiteCourseConstraint, int bCount, int lCount) {
		this(studentCount, courseCount, definiteCourseConstraint);
		m_lBCount = bCount;
		m_lICount = lCount;
	}

	public CardinalityConstraintsDemo(int studentCount, int courseCount, int definiteCourseConstraint, int bCount, int lCount, int sampleCount, String tag) {
		this(studentCount, courseCount, definiteCourseConstraint, bCount, lCount);
		m_SampleCount = sampleCount;
		m_Tag = tag;
	}
	
	public void run() {
		try {
			genParameterizedDB();
		} catch (Exception ex) {
			System.err.println(ex);			
		}
	}
	
	protected void genParameterizedDB() throws Exception {
		jython.exec("global GUID");
		for (int i = 0; i < m_SampleCount; i++) {
			jython.exec("GUID = 1");

			jython.exec("sys.argv = []");
			jython.exec("sys.argv.append('" + script + "')");
			jython.exec("sys.argv.append('" + m_StudentCount + "')");
			jython.exec("sys.argv.append('" + m_CourseCount + "')");
			jython.exec("sys.argv.append('" + m_DefiniteCourseConstraint + "')");
			jython.exec("sys.argv.append('" + m_lBCount + "')");
			jython.exec("sys.argv.append('" + m_lICount + "')");

			jython.execfile(script);
			PyObject dbObj = jython.get("db");
			if(dbObj == null) {
				throw new Exception("Generator script does not define 'db' object!");
			}
			Database db = (Database) dbObj.__tojava__(Database.class);
			db.check();
			File outFile, outFile2;
			String prefix = new String("DB-"+m_StudentCount+"-"+m_CourseCount+"-"+m_DefiniteCourseConstraint+"-"+m_lBCount+"-"+m_lICount+"-"+i);
			if (m_Tag != "") {
				prefix = prefix+"-"+m_Tag;
			}
			outFile = new File(prefix + ".db");
			outFile2 = new File(prefix + ".blogdb");
			PrintStream outDB = new PrintStream(outFile);
			db.writeMLNDatabase(outDB);
			outDB = new PrintStream(outFile2);
			db.writeBLOGDatabase(outDB);
		}
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Properties props = new Properties();
		//props.put("python.path", "datagen;bin;python");
		//props.put("python.home", "C:\\jython-2.2.1");
		props.put("python.path", "/usr/wiss/jain/work/code/SRLDB/bin:/usr/wiss/jain/work/code/SRLDB/datagen");
		PythonInterpreter.initialize(System.getProperties(), props, null);
		
		jython = new PythonInterpreter();
		jython.exec("import sys");
		CardinalityConstraintsDemo xg = null;
		try {
			
			// stochastic
			/*
			script = "gen_simple.py"; 
  			for (int i = 12; i <= 36; i++) {
				xg = new CardinalityConstraintsDemo(45,i,6,6,0,5,"Lx");
				xg.genParameterizedDB();
			}
  			*/
  			
  			// perfect
  			script = "gen_simple_exact.py";
  			for (int i = 15; i <= 35; i += 5) {
				xg = new CardinalityConstraintsDemo(45,i,6,6,0,1,"Lp");
				xg.genParameterizedDB();
			}
  			
  			// C-Classification
  			/*for (int i = 12; i <= 20; i++) {
				xg = new CardinalityConstraintsDemo(10,i,6,6,0,3,"I");
				xg.genParameterizedDB();
			}*/
			/*
			for (int i = 3; i <= 9; i = i + 3) {
				xg = new CardinalityConstraintsDemo(10,i,1,i/3,i/3,5);
				xg.genParameterizedDB();
			}*/
		} catch (Exception e) {
			System.err.println(e);
		}
	}

}
